unit MCoPXPTabControlReg;

{
     +-----------------------------------+
     \            XPTabControl           \
     \            Version 1.0.1          \
     \               2013                \
     \       http://www.dihav.com/       \
     \      vahid_you2004@yahoo.com      \
     +-----------------------------------+
}

interface

uses
  DesignEditors, DesignIntf, DesignMenus, MCoPXPTabControl, Classes,
  ShellApi, Windows, SysUtils, {$if CompilerVersion > 22}Vcl.Dialogs{$else}Dialogs{$ifend};

type

  TMCoPXPTabPageEditor = class(TDefaultEditor)
  public
    procedure ExecuteVerb(Index:Integer); override;
    function GetVerb(Index:Integer):String; override;
    function GetVerbCount:Integer; override;
    procedure PrepareItem(Index:Integer;const AItem:IMenuItem); override;
  end;

  TMCoPXPTabPageActiveTabEditor = class(TComponentProperty)
  public
    function GetValue:String; override;
    procedure SetValue(const Value:String); override;
    function GetAttributes:TPropertyAttributes; override;
    procedure GetValues(Proc:TGetStrProc); override;
  end;

  TMCoPHomepageProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetValue:String; override;
    function GetAttributes:TPropertyAttributes; override;
  end;

procedure Register;

implementation

//Menu

procedure TMCoPXPTabPageEditor.ExecuteVerb(Index:Integer);
var
  t:TMCoPXPTabControl;
  s:TMCoPXPTabSheet;
begin
if Designer=nil then Exit;
if Component is TMCoPXPTabControl then
  t:=TMCoPXPTabControl(Component)
else
  t:=TMCoPXPTabSheet(Component).TabControl;
case Index of
  0:MessageDlg('TMCoPXPTabControl v1.0.1'#13#10'By Mohammad Yousefi'#13#10'vahid_you2004@yahoo.com'#13#10'April 2013'#13#10'http://www.dihav.com/',mtInformation,[mbOK],0);
  1:ShellExecute(0,'Open','http://www.dihav.com/','','',SW_SHOW);
  3:
    begin
    s:=TMCoPXPTabSheet.Create(Designer.GetRoot);
    s.Parent:=t;
    s.TabControl:=t;
    s.Name:=GetDesigner.UniqueName('TMCoPXPTabSheet');
    s.Caption:=s.Name;
    if not Assigned(t.ActiveTab) then t.ActiveTab:=s;
    end;
  4:
    begin
    t.ActiveTab.TabControl:=nil;
    t.ActiveTab.Free;
    end;
  5:t.TabIndex:=t.TabIndex+1;
  6:t.TabIndex:=t.TabIndex-1;
end;
if Index>2 then Designer.Modified;
end;

function TMCoPXPTabPageEditor.GetVerb(Index:Integer):String;
begin
case Index of
  0:Result:='About XPTabControl';
  1:Result:='Visit Homepage';
  2:Result:='-';
  3:Result:='New Page';
  4:Result:='Delete Page';
  5:Result:='Next Page';
  6:Result:='Previous Page';
end;
end;

function TMCoPXPTabPageEditor.GetVerbCount:Integer;
begin
Result:=7;
end;

procedure TMCoPXPTabPageEditor.PrepareItem(Index:Integer;const AItem:IMenuItem);
var
  i,c:Integer;
  t:TMCoPXPTabControl;
begin
if Component is TMCoPXPTabControl then
  t:=TMCoPXPTabControl(Component)
else
  t:=TMCoPXPTabSheet(Component).TabControl;
i:=t.TabIndex;
c:=t.TabCount;
case Index of
  4:AItem.Enabled:=i>=0;
  5:AItem.Enabled:=(i<c-1) and (c<>0);
  6:AItem.Enabled:=(i>0) and (c<>0);
end;
end;

//ActiveTab

function TMCoPXPTabPageActiveTabEditor.GetAttributes:TPropertyAttributes;
begin
Result:=[paValueList];
end;

function TMCoPXPTabPageActiveTabEditor.GetValue:String;
var c:TMCoPXPTabControl;
begin
c:=GetComponent(0) as TMCoPXPTabControl;
if Assigned(c.ActiveTab) then
  Result:=c.ActiveTab.Name
else
  Result:='';
end;

procedure TMCoPXPTabPageActiveTabEditor.SetValue(const Value:String);
var
  c:TMCoPXPTabControl;
  k:Integer;
begin
c:=GetComponent(0) as TMCoPXPTabControl;
if Value='' then
  c.ActiveTab:=nil
else
  for k:=0 to c.TabCount-1 do
    if UpperCase(c.TabSheet[k].Name)=UpperCase(Value) then
      begin
      c.ActiveTab:=c.TabSheet[k];
      Break;
      end;
end;

procedure TMCoPXPTabPageActiveTabEditor.GetValues(Proc:TGetStrProc);
var
  c:TMCoPXPTabControl;
  k:Integer;
begin
c:=GetComponent(0) as TMCoPXPTabControl;
for k:=0 to c.TabCount-1 do Proc(c.TabSheet[k].Name);
end;

//Homepage

function TMCoPHomepageProperty.GetAttributes:TPropertyAttributes;
begin
Result:=[paDialog,paReadOnly];
end;

function TMCoPHomepageProperty.GetValue:String;
begin
Result:='http://www.dihav.com/';
end;

procedure TMCoPHomepageProperty.Edit;
begin
ShellExecute(0,'Open','http://www.dihav.com/','','',SW_SHOW);
end;

procedure Register;
begin
RegisterComponents('dihav',[TMCoPXPTabControl]);
RegisterComponentEditor(TMCoPXPTabControl,TMCoPXPTabPageEditor);
RegisterComponentEditor(TMCoPXPTabSheet,TMCoPXPTabPageEditor);
RegisterPropertyEditor(TypeInfo(TMCoPXPTabSheet),TMCoPXPTabControl,'ActiveTab',TMCoPXPTabPageActiveTabEditor);
RegisterPropertyEditor(TypeInfo(String),TMCoPXPTabControl,'Homepage',TMCoPHomepageProperty);
RegisterNoIcon([TMCoPXPTabSheet]);
RegisterClasses([TMCoPXPTabSheet]);
end;

end.
